#!/usr/bin/perl
use lib '/var/www/html/phpdemo/cgi/perl';
use warnings;
use strict;

use Digest::SHA1  qw(sha1_hex);

# Download CryptoPhoto Perl lib from https://cryptophoto.com/admin/api
use CryptoPhotoUtils;
use CGI;

my $server      = "https://cryptophoto.com";
my $private_key = "xxx"; # Your CryptoPhoto Private API Key
my $public_key  = "yyy"; # Your CryptoPhoto Public API Key
my $salt        = "random-salt-string";
my $uid         = "userId"; # Your users internal ID

$public_key  = "09981d34623370624bf97380c3bf2a282d41a5592a6be5f9"; # live server
$private_key = "e73a3ed9a16b36973984ed19230cc4288bb60e1598c1334c";
my $tvid = "d9af9c33e5b4d17a6008315cf6cdaee3";

my $cgi = CGI->new();
my $_POST = $cgi->Vars();

my $step = "register";
my $error = '';
my $sid = '';                     

if (exists $_POST->{'username'}) {
  # check user name
  if ($_POST->{'username'} eq 'demo') {
    # all OK
    # do CryptoPhoto authentication
    $step = 'cp_wizard';
  }
}

if ($step eq 'cp_wizard') {
  my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
  my $session = $cp->start_session($ENV{'REMOTE_ADDR'});

  if ($session->{'is_valid'}) { # API call was successful
    $sid = $session->{'sid'};
  } else {
    $error = $session->{'error'} . ( $session->{'errdesc'} ? ' ' . $session->{'errdesc'} : '' );
  }
}
  
my $display = '';

if ($error) {
  $display .= '<p>Error: ' . $error . '</p>';
}

if ($step eq 'register') {
  $display .= 'Username: <input type="text" name="username" value="demo"><br>' .
    '<input type="submit" value="Register">';
} elsif ($step eq 'cp_wizard') {
  $display .= '<div id="cp_widget" style="margin: 10px auto;">Loading...</div>' .
    '<script type="text/javascript" src="' . $server . '/api/wizard-setup?sd=' . $sid . '"></script>';
}
 
my $out=<<HTML;
Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset='UTF-8'>
<title>User Register</title>
</head>

<body style='text-align:center'>
  <h2>Register</h2>
  <form action='' method='post'>
       $display
  </form>
</body>
</html>
HTML

print $out;