#!/usr/bin/perl

use warnings;
use strict;

use Digest::SHA1  qw(sha1_hex);

# Download CryptoPhoto Perl lib from https://cryptophoto.com/admin/api
use CryptoPhotoUtils;

my $server      = "https://cryptophoto.com";
my $private_key = "xxx"; # Your CryptoPhoto Private API Key
my $public_key  = "yyy"; # Your CryptoPhoto Public API Key
my $salt        = "random-salt-string";
my $uid         = "userId"; # Your users internal ID

my $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1_hex($uid.$salt));
my $r = $cp->start_session($ENV{'REMOTE_ADDR'});

my $display = '';
my $error = '';
my $sid = '';

if ($r->{'is_valid'}) {
  $sid = $r->{'sid'};
} else {
  $error = $r->{'error'} . ( $r->{'errdesc'} ? ' ' . $r->{'errdesc'} : '' );
}

if ($sid) {
  $display = "<div id='cp_widget'>Loading...</div>" .
        "<script type='text/javascript'" .
        "src='" . $server . "/api/token?sd=" . $sid . "'>" .
        "</script>";
} elsif ($error) {
  $display = "<div>Error: " . $error . "</div>";
}

my $out = <<HTML;
Content-Type: text/html; charset=utf-8

<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>User Account</title>
</head>
<body>
  <h2>Manage Your Tokens</h2>
  $display
</body>
</html>
HTML

print $out;